"""
ISN DS 6 2014-2015
"""

##Exercice 1

alphabet = 'abcde'
n = len(alphabet)

for i in range(n):
    ligne = ''
    for lettre in alphabet[::-1]:
        ligne = ligne + lettre
    print(ligne)

"""
>>> (executing lines 13 to 17 of "DS6-15-projet.py")
edcba
edcba
edcba
edcba
edcba
"""


for lettre in alphabet[::-1]:
    ligne = ''
    for i in range(n):
        ligne = ligne + lettre
    print(ligne)

"""
>>> (executing lines 43 to 47 of "DS6-15-projet.py")
eeeee
ddddd
ccccc
bbbbb
aaaaa
"""

for lettre in alphabet:
    ligne = ''
    for i in range(n):
        ligne = ligne + lettre
    print(ligne)

"""
>>> (executing lines 28 to 32 of "DS6-15-projet.py")
aaaaa
bbbbb
ccccc
ddddd
eeeee
"""

##Exercice 2

def suite(n):
    u = 1
    for k in range(1, n+1):
        u = u + 2*k + 1
    return u

"""
#On  remarque que suite(n) est la somme des impairs successifs de 1 à 2*n+1
#La suite des impairs est arithmétique de raison 2.
# suite(n) = 1 + 3 + ... + 2*n+1 = (1+2*n+1)*(n+1)/2 = (n+1)**2
>>> [(n, suite(n)) for n in range(0,6)]
[(0, 1), (1, 4), (2, 9), (3, 16), (4, 25), (5, 36)]
"""


##Exercice 3

def verification_eleve(t, binf, bsup):
    """Fonction fausse qui devrait vérifier que tous les entiers éléments de t
    sont compris entre binf et bsup"""
    if binf > bsup:
        return None
    for e in t:
        if binf <= e and e <= bsup:
            return True
    return False

def verification_correc(t, binf, bsup):
    """Fonction correcte qui vérifie que tous les entiers éléments de t
    sont compris entre binf et bsup"""
    if binf > bsup:
        return None
    for e in t:
        if binf > e or e > bsup:
            return False
    return False


##Exercice 4

"""
from robot import *

for i in range(730):
    for j in range(11):
        haut()
    for k in range(11):
        droite()
    for m in range(11):
        bas()
    for n in range(11):
        gauche()
"""


motif1 = '#'*14
motif2 = '#'+' '*12 + '#'
motif3 = '# '+'#'*10 +' #'
for k in range(14):
    ligne = ''
    if k*(k - 13) == 0:
        ligne = ligne + motif1
    elif (k-1)*(k - 12) == 0:
        ligne = ligne + motif2
    else:
        ligne = ligne + motif3
    print(ligne)
##Exercice 5

from random import randint

def place(t, n):
    """Déterminer l'index où l'on doit insérer l'entiern
    dans le tableau t trié dans l'ordre croissant"""
    i = 0
    while i < len(t) and t[i] < n:
        i += 1
    return i

"""
>>> place([1,2,3], 4)
3
>>> place([1,2,2,3], 2)
1
>>> place([1,2,2,3], 0)
0
"""

def mystere(t):
    """Trie par insertion dans l'ordre croissant le tableau d'entiers t
    en retournant un nouveau tableau trié
    """
    template = "|{:^4}|{:^4}|{:^24}|"
    print('-'*36)
    print(template.format('i','j','new'))
    print('-'*36)
    print(template.format('Init','rien',str(t[0])))
    print('-'*36)
    new = [t[0]]
    for i in range(1, len(t)):
        j = place(new, t[i])
        new.insert(j, t[i])
        print(template.format(i,j,str(new)))
        print('-'*36)
    return new

"""
>>> mystere([6, 2, 5, 4])
------------------------------------
| i  | j  |          new           |
------------------------------------
|Init|rien|           6            |
------------------------------------
| 1  | 0  |         [2, 6]         |
------------------------------------
| 2  | 1  |       [2, 5, 6]        |
------------------------------------
| 3  | 1  |      [2, 4, 5, 6]      |
------------------------------------
[2, 4, 5, 6]
"""

##Exercice 6

def nombredecoupe(n):
    """Retourne le nombre de découpes au bout de n étapes"""
    d = 0 #nombre de découpes à l'étape courante
    r = 1 #nombre de nouveaux rectangles découpées  à l'étape suivante
    for k in range(1, n+1):
        d = d + r  #mise à jour du nombre de découpes
        r = r*8    #mise à jour du nombre de nouveax rectangles découpées
    return d

"""
>>> [(n, nombredecoupe(n)) for n in range(0, 6)]
[(0, 0), (1, 1), (2, 9), (3, 73), (4, 585), (5, 4681)]
"""

"""
On remarque que :
  r(0)=0 et pour tout entier n>= 1, r(n) = 8**(n-1) 
  donc r(n) est une suite géométrique à partir du rang 0
  et donc la somme des termes consécutifs de cette suite géométrique est :
  pour tout entier n>= 1,
  d(n) = r(1) + r(2) + ... + r(n) = (8**(n)-1)/(8-1)
"""

def nombredecoupe2(n):
    """Retourne le nombre de découpes au bout de n étapes"""
    if n == 0:
        return 0
    return (8**(n)-1)/(8-1)

"""
>>> [(n, nombredecoupe2(n)) for n in range(0, 6)]
[(0, 0), (1, 1.0), (2, 9.0), (3, 73.0), (4, 585.0), (5, 4681.0)]
"""